% logex(1) logfmt1 tool | Version 0.3


NAME
====

**logex** — extracts fields from log files which have a .log.fmt alongside - as generated by **update-logfmt**(1)

SYNOPSIS
========

  **logex** \[_file.log_] \[_field field2 field3_]

  **logex** \[**--tab**|**--csv**|**--json**|**--debug**] \[_file.log_] \[_"fields"_]

  **logex** \[**--regex**] \[_file.log_]


DESCRIPTION
===========

`logex` is a little command line tool around [`logopen()`](logopen.md).
It basically allows fetching individual fields from a log, and/or
restructuring it into a specific format (e.g. tab or comma-delimited).

  **logex** _access.log_ _request_uri_ _datetime_ _user_agent_

Where the first param is always the log file, and then an arbitrary
number of field names - either individually or as part of a string
argument:

  **logex** _access.log_ **--tab** _"uri,date,status"_ _user_agent_

Would delimit the first three per comma, the last with a tab.


Options
=======

| param | desc |
|-------|------|
| --json | output each row as JSON |
| --csv  | join all fields with comma |
| --tab  | tab-separated output |
| --iso8601 | fix any datetime fields |
| --regex | just output regex for log |
| --debug | debug_rx in case the regex fails |


Prefixes
========

The argument list allows field name prefixes.  Which are only relevant to
container-fields (expanded key:value pairs for some application formats), in
case they're holding lists.

| prefix | output |
| -------| ------ |
| @name  | will just show the first entry |
| %name  | space-separated list |
| *name  | comma-separated list |
| +name  | plus-joined list |
| #name  | as json array |
| name   | whatever |


SEE ALSO
========

**python**(1), **update-logfmt**(1), **logfmt**(5)
